Object.prototype.addMethod = function(name, method) {
  this.prototype[name] = method;
}

var createClass = function(Class, base, methods) {
  if(base !== undefined && base !== null) {
    Class.prototype = new base();
    Class.prototype.constructor = Class;
  }
  
  Class.addMethod('_super', function(methodName, args) {
    return base.prototype[methodName].call(this, args);
  })
  
  for(var methodName in methods) {
    Class.addMethod(methodName, methods[methodName]);
  }
  return Class;
}

var Vehicle = 
  createClass(
    function() { println("creating Vehicle"); this.miles = 0; return this;},
    null,
    {
      'move' : function(dist) { println('Vehicle move'); this.miles += dist; }
    }
 )

var Car =
 createClass(
   function() { println("creating Car"); },
   Vehicle,
   {
     'move' : function(dist) { println('drive'); this._super('move', dist); }
   }
)

var car = new Car();
println("Created");
car.move(10);
println(car.miles);